--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/pinmux.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/pinmux.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,945 @@
+#include <linux/version.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/fs.h>
+#include <linux/types.h>
+#include <linux/fcntl.h>
+#include <linux/ioport.h>
+#include <asm/uaccess.h>
+#include <asm/io.h>
+#include <linux/proc_fs.h>
+#include <mach/cnc1900.h>
+#include <mach/pinmux.h>
+
+#define REG_PINMUX_VER		0x000
+#define REG_PINMUX_I2C		0x004
+#define REG_PINMUX_UART	0x008
+#define REG_PINMUX_SMI		0x010
+#define REG_PINMUX_DISP	0x014
+#define REG_PINMUX_TS		0x018
+#define REG_PINMUX_DVIO	0x01c
+#define REG_PINMUX_SDIO	0x024
+
+enum pinmux_class  mode;
+volatile unsigned int *pinmux_base;
+volatile unsigned short *rc_base;
+volatile unsigned short *fpc_base;
+volatile unsigned int * gpio_base;
+
+#define REG_GPIO_SWPORTA_DDR	0x24
+#define REG_GPIO_SWPORTB_DDR  0x38
+/* ----------------------------------------------------------- */
+
+#if 1
+extern void gpio_configure_status_bit(unsigned int bit, const char * configure_cmd,char is_pinmux);
+#else
+void gpio_configure_status_bit(unsigned int bit, char * configure_cmd, char is_pinmux)
+{
+	;
+}
+#endif
+int cnc_gpio_register_module_set(const char * module, unsigned int  cnc_module_status) /* status: 0 disable, 1 enable */
+{
+	int gpionum;
+
+	if(strncmp("RC", module, 2)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(11 ,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(11 ,"CLR",1);
+		}
+	}else if(strncmp("FPC-COMMON", module, 10)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(10, "SET",1);
+			gpio_configure_status_bit(8,  "SET",1);
+			gpio_configure_status_bit(9,  "SET",1);
+			gpio_configure_status_bit(7,  "SET",1);
+			gpio_configure_status_bit(2,  "SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(10, "CLR",1);
+			gpio_configure_status_bit(9,  "CLR",1);
+			gpio_configure_status_bit(8,  "CLR",1);
+			gpio_configure_status_bit(7,  "CLR",1);
+			gpio_configure_status_bit(2,  "CLR",1);
+		}
+	}else if(strncmp("FPC-LED-SPECIAL", module, 15)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(4, "SET",1);
+			gpio_configure_status_bit(5,  "SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(4,  "CLR",1);
+			gpio_configure_status_bit(5,  "CLR",1);
+		}
+	}else if(strncmp("PCMCIA", module, 6)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(14, "SET", 1);
+			gpio_configure_status_bit(13, "SET", 1);
+			gpio_configure_status_bit(12, "SET", 1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(14, "CLR", 1);
+			gpio_configure_status_bit(13, "CLR", 1);
+			gpio_configure_status_bit(12, "CLR", 1);
+		}
+	}else if (strncmp("I2C1", module, 4)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(0,"SET",1);
+			gpio_configure_status_bit(1,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(0,"CLR",1);
+			gpio_configure_status_bit(1,"CLR",1);
+		}
+	}else if (strncmp("IR1", module, 3)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(11,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(11,"CLR",1);
+		}
+	}else if (strncmp("VGA", module, 4)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(0,"SET",1);
+			gpio_configure_status_bit(1,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(0,"CLR",1);
+			gpio_configure_status_bit(1,"CLR",1);
+		}
+	}else if (strncmp("I2C0", module, 4)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(16,"SET",1);
+			gpio_configure_status_bit(17,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(16,"CLR",1);
+			gpio_configure_status_bit(17,"CLR",1);
+		}
+	}else if (strncmp("UART1", module, 5)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(3,"SET",1);
+			gpio_configure_status_bit(6,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(3,"CLR",1);
+			gpio_configure_status_bit(6,"CLR",1);
+		}
+	}else if (strncmp("UART1-CTS_RTS", module, 13)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(14,"SET",1);
+			gpio_configure_status_bit(15,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(14,"CLR",1);
+			gpio_configure_status_bit(15,"CLR",1);
+		}
+	}else if (strncmp("SMI", module, 3)==0){
+		if (cnc_module_status == 1){
+			gpio_configure_status_bit(27,"SET",1);
+			gpio_configure_status_bit(28,"SET",1);
+			gpio_configure_status_bit(29,"SET",1);
+			gpio_configure_status_bit(30,"SET",1);
+			gpio_configure_status_bit(31,"SET",1);
+		}
+		if (cnc_module_status == 0){
+			gpio_configure_status_bit(27,"CLR",1);
+			gpio_configure_status_bit(28,"CLR",1);
+			gpio_configure_status_bit(29,"CLR",1);
+			gpio_configure_status_bit(30,"CLR",1);
+			gpio_configure_status_bit(31,"CLR",1);
+		}
+	}else if (strncmp("SDIO", module, 4)==0){
+		if (cnc_module_status == 1){
+			for (gpionum=32; gpionum<=39; gpionum ++) {
+				gpio_configure_status_bit(gpionum,"SET",1);
+			}
+		}
+		if (cnc_module_status == 0){
+			for (gpionum=32; gpionum<=39; gpionum ++) {
+				gpio_configure_status_bit(gpionum,"CLR",1);
+			}
+		}
+	}else if (strncmp("VIB", module, 3)==0 || strncmp("TTLOUT", module, 6)==0){
+		if (cnc_module_status == 1){
+			for (gpionum=40; gpionum<=63; gpionum ++) {
+				gpio_configure_status_bit(gpionum,"SET",1);
+			}
+		}
+		if (cnc_module_status == 0){
+			for (gpionum=40; gpionum<=63; gpionum ++) {
+				gpio_configure_status_bit(gpionum,"CLR",1);
+			}
+		}
+	}
+	else {
+		return 0;
+	}
+	return 1;
+}
+
+int pinmux_set_status_bit(int mode, int bit, int set)
+{
+	switch(mode){
+		case PINMUX_I2C:
+			if(set)
+				pinmux_base[REG_PINMUX_I2C>>2] |= (1<<(bit));
+			else
+				pinmux_base[REG_PINMUX_I2C>>2] &= ~(1<<(bit));
+			break;
+
+		case PINMUX_UART:
+			if(set)
+				pinmux_base[REG_PINMUX_UART>>2] |= (1<<(bit));
+			else
+				pinmux_base[REG_PINMUX_UART>>2] &= ~(1<<(bit));
+			break;
+
+		case PINMUX_DISP:
+			if(bit <= 5){
+				if(set ){
+					if(bit == TVE0_YPbPr){
+						pinmux_base[REG_PINMUX_DISP>>2] &= 0;
+					}
+					else if(bit == OUTIF0_RGB){
+						pinmux_base[REG_PINMUX_DISP>>2] |= 1<<8;
+						pinmux_base[REG_PINMUX_DISP>>2] &= ~(1<<10);
+					}
+					else if(bit == TVE1_CVBS_S_video){
+						pinmux_base[REG_PINMUX_DISP>>2] |= 1<<10;
+						pinmux_base[REG_PINMUX_DISP>>2] &= ~(1<<9);
+						pinmux_base[REG_PINMUX_DISP>>2] &= ~(1<<8);
+					}
+					else if(bit == TVE1_YPbPr){
+						pinmux_base[REG_PINMUX_DISP>>2] |= 1<<10;
+						pinmux_base[REG_PINMUX_DISP>>2] &= ~(1<<9);
+						pinmux_base[REG_PINMUX_DISP>>2] |= 1<<8;
+					}
+					else if(bit == OUTIF1_RGB){
+						pinmux_base[REG_PINMUX_DISP>>2] |= 1<< 10;
+						pinmux_base[REG_PINMUX_DISP>>2] |= 1<< 9;
+					}
+				}
+				else
+					printk("invalid bit \n");
+			}
+			else
+				printk("invalid bit \n");
+			break;
+		case PINMUX_SMI:
+			if(bit == 1){
+				if(set)
+					pinmux_base[REG_PINMUX_SMI>>2] |= (1<<(bit));
+				else
+					pinmux_base[REG_PINMUX_SMI>>2] &= ~(1<<(bit));
+			}
+			else
+				printk("invalid bit ");
+			break;
+		case PINMUX_TS:
+			if(bit == 14){
+				if(set)
+					pinmux_base[REG_PINMUX_TS>>2] |= (1<<(bit));
+				else
+					pinmux_base[REG_PINMUX_TS>>2] &= ~(1<<(bit));
+			}
+			else
+				printk("invalid bit ");
+			break;
+
+		case PINMUX_DVIO:
+			if(bit == 2 || bit==1){
+				if(set)
+					pinmux_base[REG_PINMUX_DVIO>>2] |= (1<<(bit));
+				else
+					pinmux_base[REG_PINMUX_DVIO>>2] &= ~(1<<(bit));
+			}
+			else
+				printk("invalid bit ");
+			break;
+
+		case PINMUX_SDIO:
+			if(set)
+				pinmux_base[REG_PINMUX_SDIO>>2] |= (1<<bit);
+			else
+				pinmux_base[REG_PINMUX_SDIO>>2] &= ~(1<<bit);
+			break;
+
+		default:
+			break;
+	}
+
+	return 0;
+}
+
+int pinmux_scan_status_bit(int regType)
+{
+	int ret;
+	switch(regType){
+		case PINMUX_I2C:
+			ret = pinmux_base[REG_PINMUX_I2C>>2];
+			if(ret & 0x1)
+				printk("I2C0 ENA \n");
+			else
+				printk("GPIO17:16 ENA \n");
+			if(ret & 0x2){
+				if(ret & 0x6)
+					printk(" VGA ENA \n");
+				else
+					printk("I2C1 ENA  \n");
+			}
+			else
+				printk("GPIO 1:0 ENA  \n");
+			if(ret & 0x8)
+				printk("output disp1 hsync and vsync  \n");
+			else
+				printk("output disp2 hsync and vsync  \n");
+			break;
+		case PINMUX_UART:
+			ret = pinmux_base[REG_PINMUX_UART>>2];
+			if(ret & 0x2){
+				if(ret & 0x8){
+					if(ret & 0x4)
+						printk("VIDEO UART ENA  \n");
+					else
+						printk("AUDIO UART ENA  \n");
+				}else{
+						printk("UART1 ENA  \n");
+						if(ret & 0x0c){
+							printk("UART1 RTS/CTS ENA \n");
+						}else{
+							printk("GPIO 14, 15 ENA \n");
+						}
+				}
+			}else{
+				printk("GPIO 3, 6, 14, 15 ENA  \n");
+			}
+			break;
+		case PINMUX_DISP:
+			ret = pinmux_base[REG_PINMUX_DISP>>2];
+			if(ret & 0)
+				printk("TVE0 YPbPr ENA  \n");
+			if(ret & 0x100)
+				printk("OUTIF0 RGB ENA   \n");
+			if(ret & 0x400)
+				printk("TVE1 CVBS+S-video ENA  \n");
+			if(ret & 0x500)
+				printk("TVE1 YPbPr ENA  \n");
+			if(ret & 0x600)
+				printk("OUTIF1 RGB ENA  \n");
+			break;
+		case PINMUX_SMI:
+			ret = pinmux_base[REG_PINMUX_SMI>>2];
+			if(ret & 0x1)
+				printk("SMI enable  \n");
+			else
+				printk("GPIO[31:27] enable  \n");
+			break;
+		case PINMUX_DVIO:
+			ret = pinmux_base[REG_PINMUX_DVIO>>2];
+			if(ret & 0x2)
+				printk("digital video input enable  \n");
+			else if (ret & 0x1)
+				printk("digital video output(TTL) enable  \n");
+			else
+				printk("GPIO[63:40] enable  \n");
+			break;
+		case PINMUX_SDIO:
+			ret = pinmux_base[REG_PINMUX_SDIO>>2];
+			if(ret & 0x1)
+				printk("SDIO enable  \n");
+			else
+				printk("GPIO[39:32] enable  \n");
+			break;
+		case PINMUX_TS:
+			ret = pinmux_base[REG_PINMUX_TS>>2];
+			if(ret & 0x4000)
+				printk("xport 1 enable(xport 0 and xport 1 work under serial mode)  \n");
+			else
+				printk("xport 1 disalbe(xport 0 work under parallel mode)  \n");
+			break;
+
+		default:
+			printk(" errorr  \n");
+
+	}
+	return 0;
+}
+
+int pinmux_get_status_bit(int  regType,int bit)
+{
+	int ret = 0;
+	switch(regType){
+		case PINMUX_I2C:
+			ret = pinmux_base[REG_PINMUX_I2C>>2]&(1<<(bit-1));
+			printk("the REG_PINMUX_I2C's %d bit number is %d",bit,ret);
+			break;
+		case PINMUX_UART:
+			ret = pinmux_base[REG_PINMUX_UART>>2]&(1<<(bit-1));
+			printk("the PINMUX_UART's %d bit number is %d",bit,ret);
+			break;
+		case PINMUX_SMI:
+			ret = pinmux_base[REG_PINMUX_SMI>>2]&(1<<(bit-1));
+			printk("the PINMUX_SMI's %d bit number is %d",bit,ret);
+			break;
+		case PINMUX_DISP:
+			ret = pinmux_base[REG_PINMUX_DISP>>2]&(1<<(bit-1));
+			printk("the PINMUX_DISP's %d bit number is %d",bit,ret);
+			break;
+		case PINMUX_TS:
+			ret = pinmux_base[REG_PINMUX_TS>>2]&(1<<(bit-1));
+			printk("the PINMUX_TS's %d bit number is %d",bit,ret);
+			break;
+		case PINMUX_DVIO:
+			ret = pinmux_base[REG_PINMUX_DVIO>>2]&(1<<(bit-1));
+			printk("the PINMUX_DVIO's %d bit number is %d",bit,ret);
+			break;
+		case PINMUX_SDIO:
+			ret = pinmux_base[REG_PINMUX_SDIO>>2]&(1<<(bit-1));
+			printk("the PINMUX_DVIO's %d bit number is %d",bit,ret);
+			break;
+		default :
+			printk("errorr\n");
+	}
+	return 0;
+}
+
+int pinmux_enable_gpio(GPIO_ID GPIO)
+{
+	int rt=0;
+
+	switch(GPIO){
+		case _gpio_0     :
+		case _gpio_1     :
+			pinmux_base[REG_PINMUX_I2C>>2] &= ~(1<<1);
+			cnc_gpio_register_module_set("I2C1",0);
+			break;
+		case _gpio_2     :
+			break;
+		case _gpio_3     :
+		case _gpio_6     :
+			pinmux_base[REG_PINMUX_UART>>2] &= ~(1<<1);
+			cnc_gpio_register_module_set("UART1",0);
+			break;
+		case _gpio_4     :
+			break;
+		case _gpio_5     :
+			break;
+		case _gpio_7     :
+			break;
+		case _gpio_8     :
+			break;
+		case _gpio_9     :
+			break;
+		case _gpio_10    :
+			break;
+		case _gpio_11    :
+			break;
+		case _gpio_12    :
+			break;
+		case _gpio_13    :
+			break;
+		case _gpio_14    :
+			break;
+		case _gpio_15    :
+			break;
+		case _gpio_16    :
+		case _gpio_17    :
+			break;
+		case _gpio_18    :
+		case _gpio_19    :
+			break;
+		case _gpio_20    :
+			printk("has not used \n");
+			break;
+		case _gpio_21    :
+			printk("has not used \n");
+			break;
+		case _gpio_22    :
+		case _gpio_23    :
+		case _gpio_24    :
+		case _gpio_25    :
+		case _gpio_26    :
+			break;
+		case _gpio_27    :
+		case _gpio_28    :
+		case _gpio_29    :
+		case _gpio_30    :
+		case _gpio_31    :
+			pinmux_base[REG_PINMUX_SMI>>2] &= ~1;
+			cnc_gpio_register_module_set("SMI",0);
+			break;
+		case _gpio_32    :
+		case _gpio_33    :
+		case _gpio_34    :
+		case _gpio_35    :
+		case _gpio_36    :
+		case _gpio_37    :
+		case _gpio_38    :
+		case _gpio_39    :
+			pinmux_base[REG_PINMUX_SDIO>>2] &= ~(1<<1);
+			cnc_gpio_register_module_set("SDIO",0);
+			break;
+		case _gpio_40    :
+		case _gpio_41    :
+		case _gpio_42    :
+		case _gpio_43    :
+		case _gpio_44    :
+		case _gpio_45    :
+		case _gpio_46    :
+		case _gpio_47    :
+		case _gpio_48    :
+		case _gpio_49    :
+		case _gpio_50    :
+		case _gpio_51    :
+		case _gpio_52    :
+		case _gpio_53    :
+		case _gpio_54    :
+		case _gpio_55    :
+		case _gpio_56    :
+		case _gpio_57    :
+		case _gpio_58    :
+		case _gpio_59    :
+		case _gpio_60    :
+		case _gpio_61    :
+		case _gpio_62    :
+		case _gpio_63    :
+			pinmux_base[REG_PINMUX_DVIO>>2] = 0;
+			cnc_gpio_register_module_set("DVIO",0);
+			break;
+		default:
+			;
+
+	}
+	return rt;
+
+}
+
+
+int pinmux_enable_i2c(I2C_ID I2C)
+{
+	switch(I2C)
+	{
+		case _i2c_0:
+			break;
+		case _i2c_1:
+			pinmux_base[REG_PINMUX_I2C>>2] |= (1<<1);
+			cnc_gpio_register_module_set("I2C1",1);
+			break;
+		default:
+			;
+	}
+
+	return 0;
+
+}
+
+int pinmux_enable_ir_repeater(IR_REPEATER_ID IR)
+{
+	switch(IR)
+	{
+		case _IR0:
+			break;
+		case _IR1:
+			pinmux_base[REG_PINMUX_I2C>>2] |= (1<<2);
+			cnc_gpio_register_module_set("IR1",1);
+			break;
+		default:
+			;
+	}
+
+	return 0;
+
+}
+int pinmux_enable_uart(UART_ID UART)
+{
+	switch(UART)
+	{
+		case _uart_1:
+			pinmux_base[REG_PINMUX_UART>>2] &= ~(1<<3);
+			pinmux_base[REG_PINMUX_UART>>2] |= (1<<1);
+#ifdef CONFIG_CELESTIAL_UART1_CTS_RTS
+			pinmux_base[REG_PINMUX_UART>>2] |= (1<<4);
+			cnc_gpio_register_module_set("UART1-CTS-RTS",1);
+#endif
+			break;
+		case _uart_audio:
+			pinmux_base[REG_PINMUX_UART>>2] |= (1<<1);
+			pinmux_base[REG_PINMUX_UART>>2] |= (1<<3);
+			pinmux_base[REG_PINMUX_UART>>2] &= ~(1<<2);
+			break;
+		case _uart_video:
+			pinmux_base[REG_PINMUX_UART>>2] |= (1<<1);
+			pinmux_base[REG_PINMUX_UART>>2] |= (1<<3);
+			pinmux_base[REG_PINMUX_UART>>2] |= (1<<2);
+			break;
+		default:
+			;
+	}
+	cnc_gpio_register_module_set("UART1",1);
+	return 0;
+}
+
+int pinmux_enable_smi(void)
+{
+	pinmux_base[REG_PINMUX_SMI>>2] |= 1;
+	cnc_gpio_register_module_set("SMI",1);
+	return 0;
+}
+
+int pinmux_enable_vib(void)
+{
+	pinmux_base[REG_PINMUX_DVIO>>2] = (1<<1);
+	gpio_base[REG_GPIO_SWPORTB_DDR>>2] |= 0xffffff00;
+	cnc_gpio_register_module_set("VIB",1);
+	return 0;
+}
+
+int pinmux_enable_ttlout(void)
+{
+	pinmux_base[REG_PINMUX_DVIO>>2] = 0x1;
+	cnc_gpio_register_module_set("TTL",1);
+	return 0;
+}
+
+int pinmux_set_dac0mode(DAC0_MODE Mode)
+{
+	switch(Mode)
+	{
+		case _dac0_rgb0:
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<9);
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<10));
+			break;
+		case _dac0_rgb1:
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<9);
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<10);
+			break;
+		case _dac0_tve0_ypbpr:
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<8);
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<10));
+			break;
+		case _dac0_tve0_cvbs_svideo:
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<8));
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<10));
+			break;
+		case _dac0_tve1_ypbpr:
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<8);
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<10);
+			break;
+		case _dac0_tve1_cvbs_svideo:
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<8));
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<9));
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<10);
+			break;
+	}
+
+	return 0;
+}
+
+int pinmux_set_dac1mode(DAC1_MODE Mode)
+{
+	switch(Mode){
+		case _dac1_rgb1:
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<12);
+			break;
+		case _dac1_tve1_ypbpr:
+			pinmux_base[REG_PINMUX_DISP>>2] |= (1<<11);
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<12));
+			break;
+		case _dac1_tve1_cvbs_svideo:
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<11));
+			pinmux_base[REG_PINMUX_DISP>>2] &= (~(1<<12));
+			break;
+	}
+
+	return 0;
+}
+
+int pinmux_set_xportmode(XPORT_MODE Mode)
+{
+
+	switch (Mode)
+	{
+		case _xport_serial_mode:
+			pinmux_base[REG_PINMUX_TS>>2] |= (1<<14);
+			break;
+		case _xport_paralell_mode:
+			pinmux_base[REG_PINMUX_TS>>2] &= ~(1<<14);
+			break;
+		default:
+			printk("set wrong mode \n");
+	}
+
+	return 0;
+}
+
+int pinmux_enable_tsout(int enable)
+{
+	if (enable)
+		pinmux_base[REG_PINMUX_TS>>2] |= (1<<15);
+	else
+		pinmux_base[REG_PINMUX_TS>>2] &= ~(1<<15);
+
+	return 0;
+}
+
+int pinmux_update_rc_status(void)
+{
+	unsigned short rc_ctl;
+
+	rc_ctl = rc_base[RC_CTL_H>>1] & 0x8000;
+	//    rc_ctl = rc_ctl >> 15;
+	cnc_gpio_register_module_set("RC", rc_ctl?1:0);
+	return 0;
+}
+
+#define FPC_LED_CNTL_H 		0x206 /* Led Display Control Register */
+#define FPC_KEYSCAN_CNTL_L  0x304
+int pinmux_update_fpc_status(void)
+{
+	unsigned short keyscan_ctl, led_ctl;
+	unsigned int arg;
+
+	led_ctl = fpc_base[FPC_LED_CNTL_H >> 1] & 0x8000;
+	keyscan_ctl = fpc_base[FPC_KEYSCAN_CNTL_L >>1] & 0x1;
+
+	arg = (led_ctl | keyscan_ctl) ? 1: 0;
+	cnc_gpio_register_module_set("FPC-COMMON", arg);
+
+	cnc_gpio_register_module_set("FPC-LED-SPECIAL", led_ctl? 1: 0);
+
+	return 0;
+}
+
+EXPORT_SYMBOL(pinmux_update_fpc_status);
+EXPORT_SYMBOL(pinmux_get_status_bit);
+EXPORT_SYMBOL(pinmux_set_status_bit);
+EXPORT_SYMBOL(pinmux_scan_status_bit);
+EXPORT_SYMBOL(pinmux_set_xportmode);
+EXPORT_SYMBOL(pinmux_enable_tsout);
+EXPORT_SYMBOL(pinmux_enable_uart);
+EXPORT_SYMBOL(pinmux_enable_i2c);
+EXPORT_SYMBOL(pinmux_enable_ir_repeater);
+//EXPORT_SYMBOL(pinmux_enable_irda);
+//EXPORT_SYMBOL(pinmux_enable_spi);
+EXPORT_SYMBOL(pinmux_enable_smi);
+EXPORT_SYMBOL(pinmux_enable_vib);
+EXPORT_SYMBOL(pinmux_set_dac0mode);
+EXPORT_SYMBOL(pinmux_set_dac1mode);
+EXPORT_SYMBOL(pinmux_enable_gpio);
+EXPORT_SYMBOL(pinmux_update_rc_status);
+EXPORT_SYMBOL(pinmux_enable_ttlout);
+
+static int  pinmux_proc_read(char *page, char **start, off_t off, int count, int *eof, void *data)
+{
+	int len=0;
+	int i =1;
+	int ret;
+
+	ret = pinmux_base[REG_PINMUX_I2C>>2];
+	if(ret & 0x2)
+		len += sprintf(page+len,"==> REG_PINMUX_I2C's PINMUX %d is held by I2C1 output. \n",i++);
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_I2C's PINMUX %d is held by GPIO[1:0]. \n",i++);
+
+	if(ret & 0x4)
+		len += sprintf(page+len,"==> REG_PINMUX_I2C's PINMUX %d is held by IR1. \n",i++);
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_I2C's PINMUX %d is held by GPIO[11]. \n",i++);
+
+	ret = pinmux_base[REG_PINMUX_UART>>2];
+	if(ret & 0x2){
+		if(ret & 0x8){
+			if(ret & 0x4)
+				len += sprintf(page+len,"==> REG_PINMUX_UART's PINMUX %d is held by Video UART. \n",i++);
+			else
+				len += sprintf(page+len,"==> REG_PINMUX_UART's PINMUX %d is held by Audio UART. \n",i++);
+		}
+		else{
+			len += sprintf(page+len,"==> REG_PINMUX_UART's PINMUX %d is held by UART1. \n",i++);
+			if(ret & 0x10)
+				len += sprintf(page+len,"==>UART1 with cts/rts handshake. \n");
+			else
+				len += sprintf(page+len,"==>UART1 no handshake. \n");
+		}
+	}
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_UART's PINMUX %d is held by GPIO[3,6]. \n",i++);
+
+	ret = pinmux_base[REG_PINMUX_SMI>>2];
+	if(ret & 0x1)
+		len += sprintf(page+len,"==> REG_PINMUX_SPI's PINMUX %d is held by SMI. \n",i);
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_SPI's PINMUX %d is held by GPIO[31:27]. \n",i++);
+
+	ret = pinmux_base[REG_PINMUX_DISP>>2];
+	switch((ret >>8) & 0x7){
+		case 0x0:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC0 %d is held by TVE0 CVBS+S-video. \n",i++);
+			break;
+		case 0x1:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC0 %d is held by TVE0 YPbPr. \n",i++);
+			break;
+		case 0x2:
+		case 0x3:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC0 %d is held by OUTIF0 RGB. \n",i++);
+			break;
+		case 0x4:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC0 %d is held by TVE1 CVBS+S-video. \n",i++);
+			break;
+		case 0x5:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC0 %d is held by TVE1 YPbPr. \n",i++);
+			break;
+		case 0x6:
+		case 0x7:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC0 %d is held by OUTIF1 RGB. \n",i++);
+			break;
+	}
+
+	switch((ret >>11) & 0x3){
+		case 0x0:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC1 %d is held by TVE1 CVBS+S-video. \n",i++);
+			break;
+		case 0x1:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC1 %d is held by TVE1 YPbPr. \n",i++);
+			break;
+		case 0x2:
+		case 0x3:
+			len += sprintf(page+len,"==> REG_PINMUX_DISP's DAC1 %d is held by OUTIF1 RGB. \n",i++);
+			break;
+	}
+
+	ret = pinmux_base[REG_PINMUX_TS>>2];
+	if(ret & 0x4000)
+		len += sprintf(page+len,"==> REG_PINMUX_TS's PINMUX %d xport 1 enable(xport 0 and xport 1 work under serial mode). \n",i++);
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_TS's PINMUX %d  xport 1 disalbe(xport 0 work under parallel mode). \n",i++);
+
+	if(ret & 0x8000)
+		len += sprintf(page+len,"==> REG_PINMUX_TS's PINMUX %d TS out enable(I2S output disbale). \n",i++);
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_TS's PINMUX %d TS out disalbe(I2S output enable). \n",i++);
+
+	ret = pinmux_base[REG_PINMUX_DVIO>>2];
+	if(ret & 0x1)
+		len += sprintf(page+len,"==> REG_PINMUX_DVIO's PINMUX %d is held by digital video output(TTL)\n",i++);
+	else if(ret & 0x2)
+		len += sprintf(page+len,"==> REG_PINMUX_DVIO's PINMUX %d is held by digital video input(VPB) . \n",i++);
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_DVIO's PINMUX %d is held by GPIO[63:40]. \n",i++);
+
+	ret = pinmux_base[REG_PINMUX_SDIO>>2];
+	if(ret & 0x1)
+		len += sprintf(page+len,"==> REG_PINMUX_SDIO's PINMUX %d  SDIO enable. \n",i);
+	else
+		len += sprintf(page+len,"==> REG_PINMUX_SDIO's PINMUX %d is held by GPIO[39:32] . \n",i++);
+	return len;
+
+}
+
+static int pinmux_proc_write(struct file *file, const char __user *buffer,
+		unsigned long count, void *data)
+{
+	unsigned short bit;
+	unsigned short val;
+
+	const char *cmd_line = buffer;
+
+	if (strncmp("WW_I2C", cmd_line, 6) == 0) {
+		bit = simple_strtol(&cmd_line[7], NULL, 16);
+		val = simple_strtol(&cmd_line[9], NULL, 16);
+		pinmux_set_status_bit(PINMUX_I2C, bit, val);
+	} else if (strncmp("WW_UAR", cmd_line, 6) == 0) {
+		bit = simple_strtol(&cmd_line[7], NULL, 16);
+		val = simple_strtol(&cmd_line[9], NULL, 16);
+		pinmux_set_status_bit(PINMUX_UART, bit, val);
+	}else if(strncmp("WW_DIS", cmd_line, 6) == 0){
+		bit = simple_strtol(&cmd_line[7], NULL, 16);
+		val = simple_strtol(&cmd_line[9], NULL, 16);
+		pinmux_set_status_bit(PINMUX_DISP, bit, val);
+	}else if(strncmp("WW_SMI", cmd_line, 6) == 0){
+		bit = simple_strtol(&cmd_line[7], NULL, 16);
+		val = simple_strtol(&cmd_line[9], NULL, 16);
+		pinmux_set_status_bit(PINMUX_SMI, bit, val);
+	}else if(strncmp("WW_TS1", cmd_line, 6) == 0){
+		bit = simple_strtol(&cmd_line[7], NULL, 16);
+		val = simple_strtol(&cmd_line[9], NULL, 16);
+		pinmux_set_status_bit(PINMUX_TS, bit, val);
+	}else if(strncmp("WW_DVI", cmd_line, 6) == 0){
+		bit = simple_strtol(&cmd_line[7], NULL, 16);
+		val = simple_strtol(&cmd_line[9], NULL, 16);
+		pinmux_set_status_bit(PINMUX_DVIO, bit, val);
+	}else if(strncmp("WW_SDIO", cmd_line, 6) == 0){
+		bit = simple_strtol(&cmd_line[7], NULL, 16);
+		val = simple_strtol(&cmd_line[9], NULL, 16);
+		pinmux_set_status_bit(PINMUX_SDIO, bit, val);
+	}
+	else if(strncmp("dumpreg",cmd_line,7) == 0){
+		unsigned int count = 0;
+
+		for(count = 0; count < 10; count ++){
+			if(count == 0){
+				printk("\n CNC1900_PIN_MUX_REG_BASE\n");
+			}
+			printk(" addr[0x%08x] = 0x%08x \n", CNC1900_PIN_MUX + count*4, pinmux_base[count]);
+		}
+	}
+	return count;
+}
+
+int cnc1900_pinmux_init_setting(void)
+{
+
+#ifdef CONFIG_CELESTIAL_UART1
+	pinmux_enable_uart(_uart_1);
+#endif
+	return 0;
+}
+
+static struct proc_dir_entry *cnc_pinmux_proc_entry = NULL;
+static int __init cnc19xx_pinmux_init(void)
+{
+	if (!request_mem_region(CNC1900_PIN_MUX, CNC1900_PIN_MUX_SIZE, "CNC1900 PINMUX")) {
+		printk("cnc19xx_pinmux_init request_mem_region failed.\n");
+		return -EIO;
+	}
+
+	pinmux_base = (volatile unsigned int *) ioremap(CNC1900_PIN_MUX, CNC1900_PIN_MUX_SIZE);
+	if (!pinmux_base) {
+		printk("cnc19xx_pinmux_init ioremap failed.\n");
+		return -EIO;
+	}
+
+	gpio_base =(unsigned int *) VA_GPIO_BASE;
+	rc_base = (unsigned short *)VA_FPC_BASE;
+	fpc_base = (unsigned short *)VA_FPC_BASE;
+	if (!fpc_base) {
+		printk("cnc19xx_pinmux_init  failed.\n");
+		return -EIO;
+	}
+
+	cnc_pinmux_proc_entry = create_proc_entry("cnc_pinmux", 0, NULL);
+	if (NULL != cnc_pinmux_proc_entry) {
+		cnc_pinmux_proc_entry->write_proc = &pinmux_proc_write;
+		cnc_pinmux_proc_entry->read_proc = &pinmux_proc_read;
+	}
+
+	cnc1900_pinmux_init_setting();
+	printk("cnc19xx_pinmux_init  done.\n");
+	return 0;
+}
+
+static void __exit cnc19xx_pinmux_exit(void)
+{
+	iounmap((void *) pinmux_base);
+	release_mem_region(CNC1900_PIN_MUX, CNC1900_PIN_MUX_SIZE);
+	printk("cnc19xx_pinmux_exit  done.\n");
+}
+
+postcore_initcall(cnc19xx_pinmux_init);
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/platsmp.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/platsmp.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/platsmp.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/platsmp.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,52 @@
+/*
+ * arch/arm/mach-celestial/platsmp.c
+ * Cavium CNC1900 Timer System, 2013
+ *
+ * This file is licensed unde the terms of the GNU General Public License
+ * version 2. This program is licensed "as is" without any warranty of
+ * any kind, whether express or implied.
+ */
+#include <linux/init.h>
+#include <linux/errno.h>
+#include <linux/smp.h>
+#include <linux/io.h>
+#include <linux/of_fdt.h>
+
+#include <asm/smp_scu.h>
+#include <asm/hardware/gic.h>
+#include <asm/mach/map.h>
+
+#include <mach/hardware.h>
+
+void __cpuinit platform_secondary_init(unsigned int cpu)
+{
+	printk("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nplatform_secondary_init\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
+}
+
+int __cpuinit boot_secondary(unsigned int cpu, struct task_struct *idle)
+{
+	printk("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nboot_secondary\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
+
+	return 0;
+}
+
+/*
+ * Initialise the CPU possible map early - this describes the CPUs
+ * which may be present or become present in the system.
+ */
+void __init smp_init_cpus(void)
+{
+	printk("smp_init_cpus\n");
+
+    set_smp_cross_call(gic_raise_softirq);
+}
+
+static void __init cnc19xx_smp_prepare_cpus(void)
+{
+	scu_enable(IO_ADDRESS(CNC1900_CA9_SCU));
+}
+
+void __init platform_smp_prepare_cpus(unsigned int max_cpus)
+{
+	cnc19xx_smp_prepare_cpus();
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/pmem.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/pmem.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/pmem.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/pmem.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,26 @@
+#include <linux/platform_device.h>
+#include <linux/android_pmem.h>
+#include <linux/io.h>
+
+#include <mach/hardware.h>
+
+static struct android_pmem_platform_data pmem_pdata = {
+    .name = "pmem",
+    .no_allocator = 0,
+    .cached = 0,
+    .start = PMEM_REGION,
+    .size  = PMEM_SIZE
+};
+            
+static struct platform_device pmem_dev = {
+    .name = "android_pmem",
+    .id = -1,
+    .dev = {
+		.platform_data = &pmem_pdata
+	},
+};
+
+__init int pmem_register(void)
+{
+	platform_device_register(&pmem_dev);
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/timer.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/timer.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/timer.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/timer.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,52 @@
+/*
+ * arch/arm/mach-celestial/timer.c
+ * Cavium CNC1900 Timer System, 2012
+ * 
+ * This file is licensed unde the terms of the GNU General Public License 
+ * version 2. This program is licensed "as is" without any warranty of 
+ * any kind, whether express or implied.
+ */
+#include <linux/io.h>
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/clocksource.h>
+#include <asm/mach/time.h>
+#include <asm/smp_twd.h>
+
+#include <mach/hardware.h>
+#include <mach/irqs.h>
+
+extern void __init plat_clock_init(void);
+
+static void __init gbl_clocksource_init(void)
+{
+	void __iomem *base = ioremap(CNC1900_CA9_GBL_TIMER, 0x1C);
+	struct clk *clk = clk_get_sys("smp_gbl", NULL);
+	unsigned long hz;
+
+	if (!base || !clk)
+		return;
+
+	__raw_writel(0, base + GBL_TIMER_CONTROL);
+	__raw_writel(0, base + GBL_TIMER_COUNTER_L);
+	__raw_writel(0, base + GBL_TIMER_COUNTER_H);
+	__raw_writel(0x0000FF01, base + GBL_TIMER_CONTROL);
+
+	hz = clk_get_rate(clk) / 256;
+	clocksource_mmio_init(base + GBL_TIMER_COUNTER_L, "smp_gbl", hz, 300, 32,
+		clocksource_mmio_readl_up);
+}
+
+static DEFINE_TWD_LOCAL_TIMER(local_timer, CNC1900_CA9_TWD, CPU_PRI_TIMER_IRQ);
+
+static void __init plat_timer_init(void)
+{
+	plat_clock_init();
+
+	gbl_clocksource_init();
+	twd_local_timer_register(&local_timer);
+}
+
+struct sys_timer plat_timer = {
+	.init = plat_timer_init,
+};
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/usb.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/usb.c
